%% ጟof
% USBJ荞񂾉摜
% FăgbLO(Kanade-Lucas-Tomasi (KLT) gp)
% ̈ʒuo
% oɂ͋@BwKSVM(Support Vector Machine)p
% (sɂStatistics and Machine Learning ToolboxKv)

%% 
clear; close all; clc;

%% 摜ۑtH_쐬
imdir = 'images';
%[~,~,~] = rmdir(imdir,'s');
imdirClosed = [imdir filesep 'closed'];
imdirOpened = [imdir filesep 'opened'];
[~,~,~] = mkdir(imdir);
[~,~,~] = mkdir(imdirClosed);
[~,~,~] = mkdir(imdirOpened);

%% rfIJ̏ݒ(IuWFNg`)
cam = webcam();

% \pIuWFNg쐬
videoPlayer = vision.DeployableVideoPlayer();
videoPlayerZoom = vision.DeployableVideoPlayer();

% õIuWFNg쐬
faceDetector = vision.CascadeObjectDetector(); % 猟o
eyesDetector = vision.CascadeObjectDetector('EyePairBig'); % ڌo

% |CggbJ[IuWFNg쐬(ǔ)
pointTracker = vision.PointTracker('MaxBidirectionalError', 2);

% ϐ
runLoop = true;
numPts = 0;
frameCount = 0;
eyeFlag = false;
eyeCount =  int32(0);
time = 0;
numClosed = 0;
numOpened = 0;
isCaptureClosed=false;
isCaptureOpened=false;
isTrain=false;
preEyeFlag = false;

%% Capture/Train{^쐬
sz = get(0,'ScreenSize');
figure('MenuBar','none','Toolbar','none','Position',[20 sz(4)-500 150 260])
uicontrol('Style', 'pushbutton', 'String', 'ڂ摜ۑ',...
    'Position', [20 70 120 80],...
    'Callback', 'isCaptureClosed=true;');
uicontrol('Style', 'pushbutton', 'String', 'ڂJ摜ۑ',...
    'Position', [20 160 120 80],...
    'Callback', 'isCaptureOpened=true;');
uicontrol('Style', 'pushbutton', 'String', 'wKs',...
    'Position', [20 20 120 40],...
    'Callback', 'isTrain=true;');

% g[jO摜\p
h = figure('Position', [200 30 300 500]);
subplot(2,1,1);
set(gca,'xtick',[],'ytick',[],'Xcolor','w','Ycolor','w')
title('g[jO pos摜','FontSize',14);
subplot(2,1,2);
set(gca,'xtick',[],'ytick',[],'Xcolor','w','Ycolor','w')
title('g[jO neg摜','FontSize',14);

% g[jO摜̃Zbgw
try
imds = imageDatastore(imdir,'IncludeSubfolders',true,'LabelSource','foldernames');

% g[jO摜Zbg\
figure(h);
label = categories(imds.Labels);
numLabels = numel(label);
for k = 1:numLabels
    subplot(numLabels,1,k);montage(imds.Files(imds.Labels==label(k)));
    title(label(k),'FontSize',14);
end
catch
end

%% [v
t = [];
eyeStates = [];
while (runLoop)
    % 摜f[^Lv`
    [videoFrameOrg, ts] = snapshot(cam);
    
    videoFrame = videoFrameOrg;
    videoFrameGray = rgb2gray(videoFrameOrg);
    
    % gbLOĂ|Cg10ȉ̏ꍇ͍ēx猟o
    if numPts < 10
        % 猟o
        bbox = faceDetector.step(videoFrameGray);
        
        if ~isempty(bbox)
            % oꂽ̈悩gbJ[|Cgo
            points = detectMinEigenFeatures(videoFrameGray, 'ROI', bbox(1, :));
            
            % |CggbJ[ď
            xyPoints = points.Location;
            numPts = size(xyPoints,1);
            release(pointTracker);
            initialize(pointTracker, xyPoints, videoFrameGray);
            
            % |Cg̕ۑ
            oldPoints = xyPoints;
            
            % R[i[̍Wɕϊ
            bboxPoints = bbox2points(bbox(1, :));
            
            % R[i[WEL̃xNgɕϊ [x1 y1 x2 y2 x3 y3 x4 y4]
            bboxPolygon = reshape(bboxPoints', 1, []);
            
            % Ë\
            videoFrame = insertShape(videoFrame, 'Polygon', bboxPolygon, 'LineWidth', 3);
            
            % oꂽR[i[\
            videoFrame = insertMarker(videoFrame, xyPoints, '+', 'Color', 'white');
        end
        
    else
        % gbLO[h
        [xyPoints, isFound] = step(pointTracker, videoFrameGray);
        visiblePoints = xyPoints(isFound, :);
        oldInliers = oldPoints(isFound, :);
        
        numPts = size(visiblePoints, 1);
        
        if numPts >= 10
            % Â|CgƐV|CgŊ􉽊wϊ̍s𐄒肷
            [xform, oldInliers, visiblePoints] = estimateGeometricTransform(...
                oldInliers, visiblePoints, 'similarity', 'MaxDistance', 4);
            
            % 肵sgčWɕϊ
            bboxPoints = transformPointsForward(xform, bboxPoints);
            
            % EĽ`̃xNgɕϊ [x1 y1 x2 y2 x3 y3 x4 y4]
            bboxPolygon = reshape(bboxPoints', 1, []);
            
            %  Ë\
            videoFrame = insertShape(videoFrame, 'Polygon', bboxPolygon, 'LineWidth', 3);
            
            % gbLOĂR[i[\
            videoFrame = insertMarker(videoFrame, visiblePoints, '+', 'Color', 'white');
            
            % |CgZbg
            oldPoints = visiblePoints;
            setPoints(pointTracker, oldPoints);
            
        end
        
        % ̕lp`ɃtBbeBO(ڌô)
        zoomPoints = [1 1; 200 1; 200 200; 1 200];    % c200A200
        T = fitgeotrans(bboxPoints, zoomPoints,'projective');
        rectifiedFace = imwarp(videoFrameOrg, T, 'OutputView', imref2d([200 200]));
        
        % ̕␳摜痼ڂo
        bboxEyes = step(eyesDetector, rectifiedFace);
        
        if ~isempty(bboxEyes) % ڂołꍇ
            % oꂽڂ̗̈lp`ɃtBbeBO
            bboxEyesPoints = bbox2points(bboxEyes(1,:));
            zoomPoints = [1 1; 440 1; 440 100; 1 100];    % c50A200
            T = fitgeotrans(bboxEyesPoints, zoomPoints,'projective');
            videoFrameEyes = imwarp(rectifiedFace, T, 'OutputView', imref2d([100 440]));
            
            if (isCaptureClosed || isCaptureOpened)
                % t@Cɕۑ
                if isCaptureClosed
                    isCaptureClosed = false;
                    imwrite(videoFrameEyes,...
                        [imdirClosed filesep 'frame' datestr(now,'yyyymmdd_HHMMSS_FFF') '.png']); 
                elseif isCaptureOpened
                    isCaptureOpened = false;
                    imwrite(videoFrameEyes,...
                        [imdirOpened filesep 'frame' datestr(now,'yyyymmdd_HHMMSS_FFF') '.png']);
                end
                
                % g[jO摜̃Zbgw
                imds = imageDatastore(imdir,'IncludeSubfolders',true,...
                    'LabelSource','foldernames');
                
                % g[jO摜Zbg\
                figure(h);
                label = categories(imds.Labels);
                numLabels = numel(label);
                for k = 1:numLabels
                    subplot(numLabels,1,k);montage(imds.Files(imds.Labels==label(k)));
                    title(label(k),'FontSize',14);
                end
            end
            
            % wK킪݂ꍇ͏u𔻒
            if exist('svmModel','var')
                img = imresize(videoFrameEyes, [20 88]);       % 摜TCYύX
                % HOGʂ𒊏o
                testFeatures = extractHOGFeatures(img,'CellSize',cellSize);
                % ʊɓʂnė\
                predictedLabel = predict(svmModel, testFeatures);
                eyeFlag = predictedLabel == imds.Labels(1);
                if ~preEyeFlag && eyeFlag
                    eyeCount = eyeCount + 1;
                end
                preEyeFlag = eyeFlag;
                t = [t; ts]; %#ok<AGROW>
                eyeStates = [eyeStates; eyeFlag]; %#ok<AGROW>
            else
                preEyeFlag = false;
            end
            
            % oE̓E\
            rectifiedFace = insertShape(rectifiedFace, 'Rectangle', bboxEyes(1,:), 'LineWidth', 3, 'Color', 255*[eyeFlag ~eyeFlag 0]);
        end
        
        % wKs
        if isTrain
            isTrain = false;
            
            % g[jO摜̃Zbgw
            imds = imageDatastore(imdir,'IncludeSubfolders',true,'LabelSource','foldernames');
            
            % 4x4̃ZTCYgp
            cellSize = [4 4];
            
            % \hogFeatureSizevZĂ߂1HOGo
            img = readimage(imds, 1);
            img = imresize(img, [20 88]);
            [hog_4x4, vis4x4] = extractHOGFeatures(img,'CellSize',cellSize);
            hogFeatureSize = length(hog_4x4);
            
            % trainingFeatures i[z炩ߍ쐬
            trainingFeatures  = zeros(imds.numpartitions,hogFeatureSize,'single');
            
            % Sg[jO摜HOGʂ𒊏o
            for index = 1:imds.numpartitions
                img = readimage(imds,index);
                img = imresize(img, [20 88]);
                trainingFeatures(index,:) = extractHOGFeatures(img,'CellSize',cellSize); %ʂ̒o
            end
            
            % T|[g xNg }V(SVM)̕ފ̊wK(fitcsvm() ֐gp)
            svmModel = fitcecoc(trainingFeatures, imds.Labels);
        end
        
        % Y[ʂ\
        step(videoPlayerZoom, rectifiedFace);
    end
    
    % [h\
    if exist('svmModel', 'var')
        % ܂΂o[hł邱Ƃ\
        videoFrame = insertText(videoFrame, [0 0], 'Running detection', 'FontSize', 30, 'BoxColor', 255*[0 1 0]);
        % ܂΂̉񐔂`
        videoFrame = insertText(videoFrame, [0 50],  ['Eye Closed ' num2str(eyeCount,'%d') ' times'], 'FontSize', 30);
    else
        % wK܂sĂȂƂ\
        videoFrame = insertText(videoFrame, [0 0], 'Not trained', 'FontSize', 30, 'BoxColor', [255 0 0]);
    end
    
    % \
    step(videoPlayer, videoFrame);
    
    % rfIvC[ꂽrunLoopfalseɂ
    runLoop = isOpen(videoPlayer);
    
    drawnow;
end

%% ԂƂ̂܂΂̏Ԃe[uf[^Ƃĕۑ
tbl = table(t,eyeStates,'VariableNames',{'Time','EyeStates'});
writetable(tbl,[datestr(now,'yyyymmdd_HHMMSS_FFF') '.csv']);

%% OtƂĉ
figure, plot(tbl.Time,tbl.EyeStates);
xlabel('(s)'); ylabel('');

%% ݐσOtƂĉ
figure, plot(tbl.Time,cumsum(tbl.EyeStates));
xlabel('(s)'); ylabel('');

%% Copyright 2017 The MathWorks, Inc.
